Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:48 2008
FILE NAME: i.lpj_fire.f90
PROGRAM NAME: lpj_fire
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   198  vec  (   4): Vectorized array expression.
   199  opt  (1592): Outer loop unrolled inside inner loop.
   199  vec  (   4): Vectorized array expression.
   205  vec  (   4): Vectorized array expression.
   219  vec  (   4): Vectorized array expression.
   235  vec  (   2): Partially vectorized loop.
   235  vec  (  25): Work vectors are used. Size=96byte
   247  opt  (1082): Backward transfers inhibit loop optimization.
   247  vec  (   4): Vectorized array expression.
   265  vec  (   4): Vectorized array expression.
   284  vec  (   4): Vectorized array expression.
   315  vec  (   4): Vectorized array expression.
   324  vec  (   4): Vectorized array expression.
   332  vec  (   4): Vectorized array expression.
   338  vec  (   4): Vectorized array expression.
   341  vec  (   4): Vectorized array expression.
   341  vec  (   4): Vectorized array expression.
   346  vec  (   4): Vectorized array expression.
   352  vec  (   2): Partially vectorized loop.
   352  vec  (  25): Work vectors are used. Size=96byte
   372  vec  (   4): Vectorized array expression.
   378  vec  (   4): Vectorized array expression.
   397  vec  (   2): Partially vectorized loop.
   397  vec  (  25): Work vectors are used. Size=32byte
   406  vec  (   4): Vectorized array expression.
   411  opt  (1059): Unable to determine last value of scalar temporary.
   423  vec  (   4): Vectorized array expression.
   425  vec  (   4): Vectorized array expression.
   431  vec  (   4): Vectorized array expression.
   449  vec  (   2): Partially vectorized loop.
   449  vec  (  25): Work vectors are used. Size=32byte
   453  vec  (   4): Vectorized array expression.
   466  vec  (   4): Vectorized array expression.
   487  vec  (   4): Vectorized array expression.
   487  vec  (   4): Vectorized array expression.
   541  vec  (   3): Unvectorized loop.
   541  vec  (  13): Overhead of loop division is too large.
   550  vec  (   4): Vectorized array expression.
   550  vec  (   4): Vectorized array expression.
   560  vec  (   4): Vectorized array expression.
   560  vec  (   4): Vectorized array expression.
   596  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:48 2008
FILE NAME: i.lpj_fire.f90
PROGRAM NAME: lpj_fire
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! calculate fire extent and impact on plants.
     2:            ! This is treated on a pseudo-daily basis (fireindex has a long-term memory).
     3:            ! We only take into account the natural litter, as agricultural and
     4:            !   natural PFTs are usually spatially separated.
     5:            ! Fire decreases the biomass per m**2 of natural ground.
     6:            ! Grasses are totally burned.
     7:            ! When the vegetation is dynamic, it also decreases the density of individuals.
     8:            ! Fire burns litter on the ground.
     9:            !
    10:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/lpj_fire.f90,v 1.9 2007/06/13 07:44:34 ssipsl Exp $
    11:            ! IPSL (2006)
    12:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    13:            !
    14:            MODULE lpj_fire
    15:            
    16:              ! modules used:
    17:            
    18:              USE ioipsl
    19:              USE stomate_constants
    20:              USE parallel
    21:            
    22:              IMPLICIT NONE
    23:            
    24:              ! private & public routines
    25:            
    26:              PRIVATE
    27:              PUBLIC fire,fire_clear
    28:            
    29:              ! first call
    30:              LOGICAL, SAVE                                                   :: firstcall = .TRUE.
    31:            ! flag that disable fire
    32:              LOGICAL, SAVE                                                   :: disable_fire
    33:            
    34:            CONTAINS
    35:            
    36:            
    37:              SUBROUTINE fire_clear
    38:                firstcall = .TRUE.
    39:              END SUBROUTINE fire_clear
    40:            
    41:              SUBROUTINE fire (npts, dt, space_nat, litterpart, &
    42:                               litterhum_daily, t2m_daily, lignin_struc, &
    43:                               fireindex, firelitter, biomass, ind, &
    44:                               litter, dead_leaves, bm_to_litter, black_carbon, &
    45:                               co2_fire)
    46:            
    47:                !
    48:                ! 0 declarations
    49:                !
    50:            
    51:                ! 0.1 input
    52:            
    53:                ! Domain size
    54:                INTEGER(i_std), INTENT(in)                                             :: npts
    55:                ! Time step in days
    56:                REAL(r_std), INTENT(in)                                          :: dt
    57:                ! fraction of total space that is natural
    58:                REAL(r_std), DIMENSION(npts), INTENT(in)                         :: space_nat
    59:                ! fraction of litter above the ground belonging to different PFTs
    60:                REAL(r_std), DIMENSION(npts,npft,nlitt), INTENT(in)              :: litterpart
    61:                ! Daily litter moisture (between 0 and 1)
    62:                REAL(r_std), DIMENSION(npts), INTENT(in)                         :: litterhum_daily
    63:                ! Daily 2 meter temperature (K)
    64:                REAL(r_std), DIMENSION(npts), INTENT(in)                         :: t2m_daily
    65:                ! ratio Lignine/Carbon in structural litter, above and below ground,
    66:                !   natural and agricultural (gC/(m**2 of nat/agri ground))
    67:                REAL(r_std), DIMENSION(npts,nvegtypes,nlevs), INTENT(in)         :: lignin_struc
    68:            
    69:                ! 0.2 modified fields
    70:            
    71:                ! Probability of fire
    72:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(inout)            :: fireindex
    73:                ! Longer term total natural litter above the ground, gC/m**2 of natural ground
    74:                REAL(r_std), DIMENSION(npts,nvegtypes), INTENT(inout)            :: firelitter
    75:                ! biomass (gC/m**2)
    76:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)          :: biomass
    77:                ! density of individuals (1/m**2)
    78:                REAl(r_std), DIMENSION(npts,npft), INTENT(inout)                 :: ind
    79:                ! metabolic and structural litter, natural and agricultural,
    80:                !   above and below ground (gC/m**2)
    81:                REAL(r_std), DIMENSION(npts,nlitt,nvegtypes,nlevs), INTENT(inout):: litter
    82:                ! dead leaves on ground, per PFT, metabolic and structural,
    83:                !   in gC/(m**2 of nat/agri ground)
    84:                REAL(r_std), DIMENSION(npts,npft,nlitt), INTENT(inout)           :: dead_leaves
    85:                ! conversion of biomass to litter (gC/(m**2 of average nat/agri ground)) / day
    86:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)          :: bm_to_litter
    87:                ! black carbon on the ground (gC/(m**2 of total ground))
    88:                REAL(r_std), DIMENSION(npts), INTENT(inout)                      :: black_carbon
    89:            
    90:                ! 0.3 output
    91:            
    92:                ! carbon emitted into the atmosphere by fire (living and dead biomass)
    93:                ! (in gC/m**2/day)
    94:                REAL(r_std), DIMENSION(npts), INTENT(out)                        :: co2_fire
    95:            
    96:                ! 0.4 local
    97:            
    98:                ! Time scale for memory of the fire index (days). Validated for one year in the DGVM.
    99:                REAL(r_std), PARAMETER                                           :: tau_fire = 30.  ! GKtest
   100:                ! Critical litter quantity for fire
   101:                REAL(r_std), PARAMETER                                           :: litter_crit = 200.
   102:                ! fire perturbation
   103:                REAL(r_std), DIMENSION(npts)                                     :: fire_disturb
   104:                ! what fraction of the plants is burned each day?
   105:                REAL(r_std), DIMENSION(npts,npft)                                :: firedeath 
   106:                ! What fraction of a burned plant compartment goes into the atmosphere
   107:                !   (rest into litter)
   108:                REAL(r_std), SAVE, DIMENSION(nparts)                             :: co2frac
   109:                ! Moisture limit (critical moisture limit)
   110:                REAL(r_std), DIMENSION(npts)                                     :: moistlimit
   111:                ! total litter above the ground for a vegetation type (gC/m**2)
   112:                REAL(r_std), DIMENSION(npts)                                     :: litter_above
   113:                ! daily fire index
   114:                REAL(r_std), DIMENSION(npts,nvegtypes)                           :: fireindex_daily
   115:                ! fire extent, on natural and agricultural ground
   116:                REAL(r_std), DIMENSION(npts, nvegtypes)                          :: firefrac
   117:                ! residual fraction of exposed structural litter, depending on lignin fraction
   118:                REAL(r_std), DIMENSION(npts)                                     :: struc_residual
   119:                ! residue, i.e. exposed carbon - volatilized carbon ( gC/(m**2 of nat/agri ground))
   120:                REAL(r_std), DIMENSION(npts)                                     :: residue
   121:                ! fraction of residue transformed into black carbon
   122:                REAL(r_std), DIMENSION(npts)                                     :: bcfrac
   123:                ! fraction of total space that is natural/agricultural. Allows to transform from
   124:                ! 1/(m**2 of nat/agri ground) to 1/(m**2 of total ground)
   125:                REAL(r_std), DIMENSION(npts,nvegtypes)                           :: fracspace_vegtype
   126:                ! intermediate variable
   127:                REAL(r_std), DIMENSION(npts)                                     :: x
   128:                ! annual fire fraction
   129:                REAL(r_std), DIMENSION(npts)                                     :: aff
   130:                ! are we talking about natural or agricultural ground?
   131:                INTEGER(i_std)                                                  :: ivegtype
   132:                ! index
   133:                INTEGER(i_std)                                                  :: j,k,m
   134:            
   135:                ! =========================================================================
   136:            
   137:                IF (bavard.GE.3) WRITE(numout,*) 'Entering fire'
   138:            
   139:                !
   140:                ! 1 Initializations
   141:                !
   142:            
   143:                IF ( firstcall ) THEN
   144:            
   145:                  !
   146:                  ! 1.1 What fraction of the plant compartment, if burned, is transformed into CO2
   147:                  !
   148:            
   149:                  co2frac(ileaf) = .95
   150:                  co2frac(isapabove) = .95
   151:                  co2frac(isapbelow) = 0.
   152:                  co2frac(iheartabove) = 0.3
   153:                  co2frac(iheartbelow) = 0.
   154:                  co2frac(iroot) = 0.
   155:                  co2frac(ifruit) = .95
   156:                  co2frac(icarbres) = 0.95
   157:            
   158:                  !
   159:                  ! 1.2 messages
   160:                  !
   161:            
   162:                  WRITE(numout,*) 'fire:'
   163:            
   164:                  WRITE(numout,*) '   > temporal inertia of fire probability (d): ',tau_fire
   165:            
   166:                  WRITE(numout,*) '   > fraction of burned biomass that becomes CO2:'
   167:                  WRITE(numout,*) '     leaves: ', co2frac(ileaf)
   168:                  WRITE(numout,*) '     sap above ground: ', co2frac(isapabove)
   169:                  WRITE(numout,*) '     sap below ground: ', co2frac(isapbelow)
   170:                  WRITE(numout,*) '     heartwood above ground: ', co2frac(iheartabove)
   171:                  WRITE(numout,*) '     heartwood below ground: ', co2frac(iheartbelow)
   172:                  WRITE(numout,*) '     roots: ', co2frac(iroot)
   173:                  WRITE(numout,*) '     fruits: ', co2frac(ifruit)
   174:                  WRITE(numout,*) '     carbohydrate reserve: ', co2frac(icarbres)
   175:            
   176:                  WRITE(numout,*) '   > critical litter quantity (gC/m**2): ',litter_crit
   177:                  WRITE(numout,*) '   > We calculate a fire probability on agricultural ground, but'
   178:                  WRITE(numout,*) '       the effective fire fraction is zero.'
   179:            
   180:                  firstcall = .FALSE.
   181:                  !
   182:                  ! 1.3 read the flag that disable fire
   183:                  !
   184:                !Config  Key  = FIRE_DISABLE
   185:                !Config  Desc = no fire allowed
   186:                !Config  Def  = n
   187:                !Config  Help = With this variable, you can allow or not
   188:                !Config         the estimation of CO2 lost by fire
   189:                !
   190:                  disable_fire=.FALSE.
   191:                  CALL getin_p('FIRE_DISABLE', disable_fire)
   192:                ENDIF
   193:            
   194:                !
   195:                ! 1.4 Initialize output
   196:                !
   197:            
   198: V======        co2_fire(:) = 0.0
   199: +V=====        firedeath(:,:) = 0.0
   200:            
   201:                !
   202:                ! 1.5 fraction of total space reserved for vegetation type
   203:                !
   204:            
   205: V------>       fracspace_vegtype(:,inat) = space_nat(:)
   206: V------        fracspace_vegtype(:,iagri) = 1. - space_nat(:)
   207:            
   208:                !
   209:                ! 2 Determine fire probability. We calculate this probability (and long-term litter)
   210:                !   also for agricultural ground, but the fire fraction on agricultural ground is set
   211:                !   to 0 for the moment.
   212:                !
   213:            
   214:            
   215: +------>       DO ivegtype = 1, nvegtypes
   216: |          
   217: |                ! total litter above the ground, for the vegetation type we are talking about
   218: |          
   219: |V----->         litter_above(:) = litter(:,imetabolic,ivegtype,iabove) + &
   220: ||                                 litter(:,istructural,ivegtype,iabove)
   221: ||         
   222: ||               !
   223: ||               ! 2.1 calculate moisture limit. If it stays 0, this means that there is no litter
   224: ||               !     on the ground, and this means that there can be no fore.
   225: ||               !     Sum over different litter parts from the various PFTs, taking into account the 
   226: ||               !       litter flamability which is a function of the PFT. 
   227: ||               !     Difference to Stephen Sitch's approach: Daily litter, not annual mean.
   228: ||               !     Reason: 1. seems more reasonable.
   229: ||               !             2. easier to implement (otherwise, would need moisture limit
   230: ||               !                from previous year)
   231: ||               !
   232: ||         
   233: |V-----          moistlimit(:) = 0.
   234: |          
   235: |V----->         DO j = 1, npft
   236: ||         
   237: ||                 ! If we are on natural ground, only take natural PFTs, and vice versa
   238: ||         
   239: ||      S          IF ( ( ( ivegtype .EQ. inat ) .AND. natural(j) ) .OR. &
   240: ||                      ( ( ivegtype .EQ. iagri ) .AND. .NOT. natural(j) ) ) THEN
   241: ||         
   242: ||                   ! fire only when above feezing point and when there is litter
   243: ||                   !   (structural or metabolic) above the ground.
   244: ||                   ! Loop over grid points is the innermost because of vectorization. 
   245: ||                   !   (Makes the code unreadable.)
   246: ||         
   247: ||V---->             WHERE ( ( t2m_daily(:) .GT. ZeroCelsius ) .AND. &
   248: |||                          ( litter_above(:) .GT. min_stomate  )        )
   249: |||        
   250: ||V----                moistlimit(:) = moistlimit(:) + &
   251: ||                       ( litterpart(:,j,imetabolic)*litter(:,imetabolic,ivegtype,iabove) + &
   252: ||                         litterpart(:,j,istructural)*litter(:,istructural,ivegtype,iabove)  ) / &
   253: ||                       litter_above(:) * flam(j)
   254: ||         
   255: ||                   ENDWHERE
   256: ||         
   257: ||                 ENDIF     ! PFT and vegetation type coherent?
   258: ||         
   259: |V-----          ENDDO       ! PFT
   260: |          
   261: |                !
   262: |                ! 2.2 daily fire index.
   263: |                !
   264: |          
   265: |V----->         WHERE ( moistlimit(:) .GT. 0.0 )
   266: ||         
   267: ||                 ! is a function of litter humidity. Very sensible to STOMATE's time step as
   268: ||                 ! with larger dt, one misses dry days with very high fireindex ( strongly
   269: ||                 ! nonlinear: exp(-x^2)! )
   270: ||         
   271: ||                 x(:) = litterhum_daily(:)/moistlimit(:)
   272: ||                 fireindex_daily(:,ivegtype) = EXP( - pi * x(:) * x(:) )
   273: ||         
   274: ||               ELSEWHERE
   275: ||         
   276: |V-----            fireindex_daily(:,ivegtype) = 0.0
   277: |          
   278: |                ENDWHERE
   279: |          
   280: |                !
   281: |                ! 2.3 increase long-term fire index (mean probability)
   282: |                !
   283: |          
   284: |V----->         fireindex(:,ivegtype) = &
   285: ||                 ( ( tau_fire - dt ) * fireindex(:,ivegtype) + &
   286: ||                   ( dt )      * fireindex_daily(:,ivegtype)    ) / tau_fire
   287: ||         
   288: ||               !
   289: ||               ! 2.4 litter influences fire intensity.
   290: ||               !     We use longer-term litter to be consistent with the fire index.
   291: ||               !
   292: ||         
   293: |V-----          firelitter(:,ivegtype) = &
   294: |                  ( ( tau_fire-dt ) * firelitter(:,ivegtype) + dt * litter_above(:) ) / tau_fire
   295: |          
   296: +------        ENDDO
   297:            
   298:                !
   299:                ! 3 Calculate fire fraction from litter and fireindex (i.e. basically drought)
   300:                !   We assume that agricultural space is separated from natural space so that
   301:                !   the fire occurence on natural ground does not depend on the litter
   302:                !   on agricultural ground.
   303:                !
   304:            
   305:                !
   306:                ! 3.1 natural ground
   307:                !
   308:            
   309:                !     This formulation has been developped for annual fire indices!
   310:                !     original form: firefrac(i) = fireindex(i) * EXP( f(fireindex(i)) )
   311:                !     Transform into daily fire fraction.
   312:            
   313:                ! annual fire fraction
   314:            
   315: V======        aff(:) = firefrac_func (npts, fireindex(:,inat))
   316:            
   317:                ! transform from annual fraction to daily fraction. 
   318:                ! annual fire fraction = 1. - (fraction of tree that survives each day) ** 365 =
   319:                !                      = 1. - ( 1. - daily fire fraction )**365
   320:                ! Thus, daily fire fraction = 1. - ( 1. - annual fire fraction )**(1/365)
   321:                ! If annual firefrac<<1, then firefrac_daily = firefrac * dt/one_year
   322:                ! This approximation avoids numerical problems.
   323:              
   324: V------>       WHERE ( aff(:) .GT. 0.1 )
   325: |                firefrac(:,inat) = 1. - ( 1. - aff(:) ) ** (dt/one_year)
   326: |              ELSEWHERE
   327: V------          firefrac(:,inat) = aff(:) * dt/one_year
   328:                ENDWHERE
   329:            
   330:                ! No fire if litter is below critical value
   331:            
   332: V------>       WHERE ( firelitter(:,inat) .LT. litter_crit )
   333: V------          firefrac(:,inat) = 0.0
   334:                ENDWHERE
   335:            
   336:                ! However, there is a minimum fire extent
   337:            
   338: V======        firefrac(:,inat) = MAX( 0.001_r_std * dt/one_year, firefrac(:,inat) )
   339:            
   340:                ! if FIRE_DISABLE flag is set no fire
   341: +V=====        IF (disable_fire) firefrac=0
   342:                !
   343:                ! 3.2 agricultural ground: no fire for the moment
   344:                !
   345:            
   346: V======        firefrac(:,iagri) = 0.0
   347:            
   348:                !
   349:                ! 4 Determine fire impact: calculate fire disturbance for each PFT
   350:                !
   351:            
   352: V------>       DO j = 1, npft
   353: |          
   354: |                !
   355: |                ! 4.1 are we talking about a natural or an agricultural PFT?
   356: |                !
   357: |          
   358: |                IF ( natural(j) ) THEN
   359: |                  ivegtype = inat
   360: |                ELSE
   361: |                  ivegtype = iagri
   362: |                ENDIF
   363: |          
   364: |                !
   365: |                ! 4.2 fire disturbance
   366: |                !
   367: |          
   368: |       S        IF ( tree(j) ) THEN
   369: |          
   370: |                  ! 4.2.1 Trees: always disturbed
   371: |          
   372: |V=====            fire_disturb(:) = ( 1. - resist(j) ) * firefrac(:,ivegtype)
   373: |          
   374: |                ELSE
   375: |          
   376: |                  ! 4.2.2 Grasses are not disturbed if they are not in their growing season
   377: |          
   378: |V----->           WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
   379: ||         
   380: ||                   fire_disturb(:) = ( 1. - resist(j) ) * firefrac(:,ivegtype)
   381: ||         
   382: ||                 ELSEWHERE
   383: ||         
   384: |V-----              fire_disturb(:) = 0.0
   385: |          
   386: |                  ENDWHERE
   387: |          
   388: |                ENDIF
   389: |          
   390: |                !
   391: |                ! 4.3 litter and co2 created through fire on living biomass
   392: |                !
   393: |          
   394: |                ! biomass can go into litter or atmosphere, depending on what plant compartment
   395: |                ! we are talking about.
   396: |          
   397: |V----->         DO k = 1, nparts
   398: ||         
   399: ||                 ! grass roots and reserve survive.
   400: ||         
   401: ||      S          IF ( .NOT. ( ( .NOT. tree(j) ) .AND. ( ( k.EQ.iroot ) .OR. ( k.EQ.icarbres ) ) ) ) THEN
   402: ||         
   403: ||                   ! 4.3.1 A fraction goes directly into the atmosphere.
   404: ||                   !       CO2 flux in gC/m**2 of total ground/day.
   405: ||         
   406: ||V---->             co2_fire(:) = co2_fire(:) + biomass(:,j,k) * fire_disturb(:) * co2frac(k) * &
   407: |||                                fracspace_vegtype(:,ivegtype) / dt
   408: |||        
   409: |||                  ! 4.3.2 Determine the residue, in gC/m**2 of natural/agricultural ground.
   410: |||        
   411: ||V----              residue(:) = biomass(:,j,k) * fire_disturb(:) * ( 1. - co2frac(k) )
   412: ||         
   413: ||                   ! 4.3.2.1 determine fraction of black carbon. Only for plant parts above the
   414: ||                   !         ground, i.e. when co2_frac > 0.
   415: ||                   !         A small part of the residue, which can be expressed as a function of
   416: ||                   !         the fraction of volatilized carbon (assimilated to co2frac here),
   417: ||                   !         becomes black carbon, and thus withdrawn from the soil carbon cycle (added
   418: ||                   !         to the "geologic carbon cycle we don't care about here).
   419: ||                   !         [Kuhlbusch et al. JGR 101, 23651-23665, 1996; Kuhlbusch & Crutzen, GBC 9,
   420: ||                   !          491-501, 1995].
   421: ||           
   422: ||      S            IF ( co2frac(k) .GT. 0.0 ) THEN
   423: ||V====                bcfrac(:) = .3 / ( 1.3 ** ( 88.2 - 100.*co2frac(k) ) + 1. )
   424: ||                   ELSE
   425: ||V====                bcfrac(:) = 0.0
   426: ||                   ENDIF
   427: ||           
   428: ||                   ! 4.3.2.2 Add this fraction of the residue to the black carbon "reservoir", in
   429: ||                   !         gC/(m**2 of total ground).
   430: ||           
   431: ||V---->             black_carbon(:) = &
   432: |||                     black_carbon(:) + bcfrac(:) * residue(:) * fracspace_vegtype(:,ivegtype)
   433: |||          
   434: |||                  ! 4.3.2.3 The rest (largest part) of the residue becomes litter.
   435: |||          
   436: ||V----              bm_to_litter(:,j,k) = bm_to_litter(:,j,k) + residue(:) * ( 1 - bcfrac(:) )
   437: ||         
   438: ||                 ENDIF  ! not for grass roots
   439: ||           
   440: |V-----          ENDDO
   441: |          
   442: |                !
   443: |                ! 4.4 new vegetation characteristics
   444: |                !
   445: |          
   446: |                ! 4.4.1 decrease biomass per m**2 of natural(/agricultural) ground
   447: |                !       except for grass roots.
   448: |          
   449: |V----->         DO k = 1, nparts
   450: ||         
   451: ||      S          IF ( .NOT. ( ( .NOT. tree(j) ) .AND. ( ( k.EQ.iroot ) .OR. ( k.EQ.icarbres) ) ) ) THEN
   452: ||         
   453: ||V====              biomass(:,j,k) = ( 1. - fire_disturb(:) ) * biomass(:,j,k)
   454: ||         
   455: ||                 ENDIF
   456: ||         
   457: |V-----          ENDDO
   458: |          
   459: |                ! 4.4.2 If vegetation is dynamic, then decrease the density of tree
   460: |                !       individuals.
   461: |          
   462: |       S        IF ( control%ok_dgvm .AND. tree(j) ) THEN
   463: |          
   464: |                  ! fraction of plants that dies each day.
   465: |                  ! exact formulation: 1. - (1.-fire_disturb(:)) ** (1./dt)
   466: |V----->           firedeath(:,j) = fire_disturb(:) / dt
   467: ||         
   468: |V-----            ind(:,j) = ( 1. - fire_disturb(:) ) * ind(:,j)
   469: |          
   470: |                ENDIF
   471: |          
   472: V------        ENDDO      ! loop over PFTs
   473:            
   474:                !
   475:                ! 5 A fraction of the (natural) litter is burned by the fire
   476:                !
   477:            
   478: *------>       DO ivegtype = 1,nvegtypes
   479: |          
   480: |                !
   481: |                ! 5.1 exposed metabolic litter burns totally and goes directly into the atmosphere as
   482: |                !     CO2.
   483: |                !
   484: |          
   485: |                ! 5.1.1 CO2 flux, in gC/(m**2 of total ground)/day.
   486: |          
   487: |V----->         co2_fire(:) = co2_fire(:) + litter(:,imetabolic,ivegtype,iabove) * &
   488: ||                                           firefrac(:,ivegtype) * fracspace_vegtype(:,ivegtype) / dt
   489: ||         
   490: ||               ! 5.1.2 decrease metabolic litter
   491: ||         
   492: ||               litter(:,imetabolic,ivegtype,iabove) = litter(:,imetabolic,ivegtype,iabove) * &
   493: ||                                                      ( 1. - firefrac(:,ivegtype) )
   494: ||         
   495: ||               !
   496: ||               ! 5.2 exposed structural litter is not totally transformed into CO2.
   497: ||               !
   498: ||         
   499: ||               ! 5.2.1 Fraction of exposed structural litter that does not
   500: ||               !       burn totally should depend on lignin content (lignin_struc). VERY TENTATIVE!
   501: ||         
   502: ||               struc_residual(:) = 0.5 * lignin_struc(:,ivegtype,iabove)
   503: ||         
   504: ||               ! 5.2.2 CO2 flux, in gC/(m**2 of total ground)/day.
   505: ||         
   506: ||               co2_fire(:) = co2_fire(:) + &
   507: ||                             litter(:,istructural,ivegtype,iabove) * firefrac(:,ivegtype) * &
   508: ||                               ( 1. - struc_residual(:) ) * fracspace_vegtype(:,ivegtype) / dt
   509: ||         
   510: ||               ! 5.2.3 determine residue (litter that undergoes fire, but is not transformed
   511: ||               !       into CO2)
   512: ||         
   513: ||               residue(:) = litter(:,istructural,ivegtype,iabove) * firefrac(:,ivegtype) * &
   514: ||                            struc_residual(:)
   515: ||         
   516: ||               ! 5.2.4 determine fraction of black carbon in the residue.
   517: ||               !       depends on volatilized fraction of carbon (see 4.3.2.1)
   518: ||         
   519: ||               bcfrac(:) = .3 / ( 1.3 ** ( 88.2 - 100.*(1.-struc_residual(:)) ) + 1. )
   520: ||         
   521: ||               ! 5.2.5 Add this fraction of the residue to the black carbon "reservoir", in
   522: ||               !       gC/(m**2 of total ground).
   523: ||         
   524: ||               black_carbon(:) = &
   525: ||                  black_carbon(:) + bcfrac(:) * residue(:) * fracspace_vegtype(:,ivegtype)
   526: ||         
   527: ||               ! 5.2.6 The rest (largest part) of the residue remains litter. Remaining litter
   528: ||               !       is the sum of this and of the litter which has not undergone a fire.
   529: ||         
   530: |V-----          litter(:,istructural,ivegtype,iabove) = &
   531: |                       litter(:,istructural,ivegtype,iabove) * ( 1. - firefrac(:,ivegtype) ) + &
   532: |                       residue(:) * ( 1. - bcfrac(:) )
   533: |          
   534: *------        ENDDO  ! natural/agricultural ground
   535:            
   536:                !
   537:                ! 5.3 diagnose fraction of leaves burned.
   538:                !     exposed leaves are burned entirely, even their structural part
   539:                !
   540:            
   541: +------>       DO j = 1, npft
   542: |          
   543: |                IF ( natural(j) ) THEN
   544: |                  m = inat
   545: |                ELSE
   546: |                  m = iagri
   547: |                ENDIF
   548: |          
   549: |+----->         DO k = 1, nlitt
   550: ||V====            dead_leaves(:,j,k) = dead_leaves(:,j,k) * ( 1. - firefrac(:,m) )
   551: |+-----          ENDDO
   552: |          
   553: +------        ENDDO
   554:            
   555:                !
   556:                ! 6 history
   557:                !
   558:            
   559:                ! output in 1/day
   560: +V=====        firefrac = firefrac / dt
   561:            
   562:                CALL histwrite (hist_id_stomate, 'FIREFRAC_NAT', itime, &
   563:                                firefrac(:,inat), npts, hori_index)
   564:                CALL histwrite (hist_id_stomate, 'FIREFRAC_AGRI', itime, &
   565:                                firefrac(:,iagri), npts, hori_index)
   566:                CALL histwrite (hist_id_stomate, 'FIREDEATH', itime, &
   567:                                firedeath(:,:), npts*npft, horipft_index)
   568:            
   569:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving fire'
   570:            
   571:              END SUBROUTINE fire
   572:            
   573:              FUNCTION firefrac_func (npts, x) RESULT (firefrac_result)
   574:            
   575:                !
   576:                ! 0 declarations
   577:                !
   578:            
   579:                ! 0.1 input
   580:            
   581:                ! Domain size
   582:                INTEGER(i_std), INTENT(in)                                             :: npts
   583:                ! fire index
   584:                REAL(r_std), DIMENSION(npts), INTENT(in)                         :: x
   585:            
   586:                ! 0.2 result
   587:            
   588:                ! fire fraction
   589:                REAL(r_std), DIMENSION(npts)                                     :: firefrac_result
   590:            
   591:                ! 0.3 local
   592:            
   593:                ! intermediate variable
   594:                REAL(r_std), DIMENSION(npts)                                     :: xm1
   595:            
   596: V------>       xm1(:) = x(:) - 1.
   597: |          
   598: V------        firefrac_result(:) = &
   599:                  x(:) * EXP( xm1(:) / ( -.13*xm1(:)*xm1(:)*xm1(:) + .6*xm1(:)*xm1(:) + .8*xm1(:) + .45 ) )
   600:            
   601:              END FUNCTION firefrac_func
   602:            
   603:            END MODULE lpj_fire
