Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:50 2008
FILE NAME: i.lpj_light.f90
PROGRAM NAME: lpj_light
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   165  vec  (   1): Vectorized loop.
   177  vec  (   4): Vectorized array expression.
   186  vec  (   4): Vectorized array expression.
   196  vec  (   4): Vectorized array expression.
   197  vec  (   3): Unvectorized loop.
   198  vec  (   4): Vectorized array expression.
   199  opt  (1592): Outer loop unrolled inside inner loop.
   205  opt  (1592): Outer loop unrolled inside inner loop.
   205  vec  (   4): Vectorized array expression.
   222  vec  (   4): Vectorized array expression.
   229  vec  (   4): Vectorized array expression.
   242  vec  (   1): Vectorized loop.
   254  vec  (  26): Macro operation Sum/InnerProd.
   258  vec  (  26): Macro operation Sum/InnerProd.
   262  opt  (1019): Feedback of scalar value from one loop pass to another.
   262  vec  (  26): Macro operation Max/Min.
   276  vec  (  26): Macro operation Sum/InnerProd.
   288  opt  (1059): Unable to determine last value of scalar temporary.
   303  vec  (   1): Vectorized loop.
   387  vec  (   1): Vectorized loop.
   421  vec  (   3): Unvectorized loop.
   421  vec  (  13): Overhead of loop division is too large.
   425  vec  (   4): Vectorized array expression.
   462  vec  (   1): Vectorized loop.
   474  vec  (   4): Vectorized array expression.
   485  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:50 2008
FILE NAME: i.lpj_light.f90
PROGRAM NAME: lpj_light
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! Light competition
     2:            !
     3:            ! If canopy is almost closed (fpc > fpc_crit), then trees outcompete grasses.
     4:            ! fpc_crit is normally fpc_crit.
     5:            ! Here, fpc ("foilage protected cover") also takes into account the minimum fraction
     6:            ! of space covered by trees through branches etc. This is done to prevent strong relative
     7:            ! changes of fpc from one day to another for deciduous trees at the beginning of their
     8:            ! growing season, which would yield to strong cutbacks (see 3.2.1.1.2)
     9:            ! No competition between woody pfts (height of individuals is not considered) !
    10:            ! Exception: when one woody pft is overwhelming (i.e. fpc > fpc_crit). In that
    11:            ! case, eliminate all other woody pfts and reduce dominant pft to fpc_crit.
    12:            ! Age of individuals is not considered. In reality, light competition would more
    13:            ! easily kill young individuals, thus increasing the mean age of the stand.
    14:            ! Exclude agricultural pfts from competition
    15:            !
    16:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/lpj_light.f90,v 1.7 2007/05/28 14:49:02 ssipsl Exp $
    17:            ! IPSL (2006)
    18:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    19:            !
    20:            MODULE lpj_light
    21:            
    22:              ! modules used:
    23:            
    24:              USE ioipsl
    25:              USE stomate_constants
    26:            
    27:              IMPLICIT NONE
    28:            
    29:              ! private & public routines
    30:            
    31:              PRIVATE
    32:              PUBLIC light, light_clear
    33:            
    34:              ! first call
    35:              LOGICAL, SAVE                                            :: firstcall = .TRUE.
    36:            
    37:            CONTAINS
    38:            
    39:              SUBROUTINE light_clear
    40:                firstcall=.TRUE.
    41:              END SUBROUTINE light_clear
    42:            
    43:              SUBROUTINE light (npts, dt, &
    44:                                PFTpresent, cn_ind, lai, maxfpc_lastyear, &
    45:                                ind, biomass, veget_lastlight, bm_to_litter)
    46:            
    47:                !
    48:                ! 0 declarations
    49:                !
    50:            
    51:                ! 0.1 input
    52:            
    53:                ! Domain size
    54:                INTEGER(i_std), INTENT(in)                                      :: npts
    55:                ! Time step (days)
    56:                REAL(r_std), INTENT(in)                                   :: dt
    57:                ! Is pft there
    58:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                :: PFTpresent
    59:                ! crown area of individuals (m**2)
    60:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)             :: cn_ind
    61:                ! leaf area index OF AN INDIVIDUAL PLANT
    62:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)             :: lai
    63:                ! last year's maximum fpc for each natural PFT, on *natural* ground
    64:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)             :: maxfpc_lastyear
    65:            
    66:                ! 0.2 modified fields
    67:            
    68:                ! Number of individuals / m2
    69:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)          :: ind
    70:                ! biomass (gC/(m**2 of nat/agri ground))
    71:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)   :: biomass
    72:                ! Vegetation cover after last light competition
    73:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)          :: veget_lastlight
    74:                ! biomass taken away (gC/m**2)
    75:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)   :: bm_to_litter
    76:            
    77:                ! 0.3 local
    78:            
    79:                ! maximum total number of grass individuals in a closed canopy
    80:                REAL(r_std), PARAMETER                                    :: grass_mercy = 0.01
    81:                ! minimum fraction of trees that survive even in a closed canopy
    82:                REAL(r_std), PARAMETER                                    :: tree_mercy = 0.01
    83:                ! for diagnosis of fpc increase, compare today's fpc to last year's maximum (T) or
    84:                !   to fpc of last time step (F)?
    85:                LOGICAL, PARAMETER                                       :: annual_increase = .TRUE.
    86:                ! index
    87:                INTEGER(i_std)                                            :: i,j
    88:                ! total natural fpc
    89:                REAL(r_std), DIMENSION(npts)                              :: sumfpc
    90:                ! total natural woody fpc
    91:                REAL(r_std)                                               :: sumfpc_wood
    92:                ! change in total woody fpc
    93:                REAL(r_std)                                               :: sumdelta_fpc_wood
    94:                ! maximum wood fpc
    95:                REAL(r_std)                                               :: maxfpc_wood
    96:                ! which woody pft is maximum
    97:                INTEGER(i_std)                                            :: optpft_wood
    98:                ! total natural grass fpc
    99:                REAL(r_std)                                               :: sumfpc_grass
   100:                ! this year's foliage protected cover on natural part of the grid cell
   101:                REAL(r_std), DIMENSION(npts,npft)                         :: fpc_nat
   102:                ! fpc change within last year
   103:                REAL(r_std), DIMENSION(npft)                              :: deltafpc
   104:                ! Relative change of number of individuals for trees
   105:                REAL(r_std)                                               :: reduct
   106:                ! Fraction of plants that survive
   107:                REAL(r_std), DIMENSION(npft)                              :: survive
   108:                ! number of grass PFTs present in the grid box
   109:                INTEGER(i_std)                                            :: num_grass
   110:                ! New total grass fpc
   111:                REAL(r_std)                                               :: sumfpc_grass2
   112:                ! fraction of plants that dies each day (1/day)
   113:                REAL(r_std), DIMENSION(npts,npft)                         :: light_death
   114:            
   115:                ! =========================================================================
   116:            
   117:                IF (bavard.GE.3) WRITE(numout,*) 'Entering light'
   118:            
   119:                !
   120:                ! 1 first call
   121:                !
   122:            
   123:                IF ( firstcall ) THEN
   124:            
   125:                  WRITE(numout,*) 'light:'
   126:            
   127:                  WRITE(numout,*) '   > Maximum total number of grass individuals in'
   128:                  WRITE(numout,*) '       a closed canopy: ', grass_mercy
   129:            
   130:                  WRITE(numout,*) '   > Minimum fraction of trees that survive even in'
   131:                  WRITE(numout,*) '       a closed canopy: ', tree_mercy
   132:            
   133:                  WRITE(numout,*) '   > For trees, minimum fraction of crown area covered'
   134:                  WRITE(numout,*) '       (due to its branches etc.)', min_cover
   135:            
   136:                  WRITE(numout,*) '   > for diagnosis of fpc increase, compare today''s fpc'
   137:                  IF ( annual_increase ) THEN
   138:                    WRITE(numout,*) '     to last year''s maximum.'
   139:                  ELSE
   140:                    WRITE(numout,*) '     to fpc of the last time step.'
   141:                  ENDIF
   142:            
   143:                  firstcall = .FALSE.
   144:            
   145:                ENDIF
   146:            
   147:                !
   148:                ! 2 fpc characteristics
   149:                !
   150:            
   151:                !
   152:                ! 2.1 calculate fpc on natural part of grid cell.
   153:                !
   154:            
   155: +------>       DO j = 1, npft
   156: |          
   157: |                IF ( natural(j) ) THEN
   158: |          
   159: |                  ! 2.1.1 natural PFTs
   160: |          
   161: |                  IF ( tree(j) ) THEN
   162: |          
   163: |                    ! 2.1.1.1 trees: minimum cover due to stems, branches etc.
   164: |          
   165: |V----->             DO i = 1, npts
   166: ||         
   167: ||                     fpc_nat(i,j) = &
   168: ||                        cn_ind(i,j) * ind(i,j) * &
   169: ||                        MAX( ( 1._r_std - exp( -lai(i,j) * ext_coeff(j) ) ), min_cover )
   170: ||         
   171: |V-----              ENDDO
   172: |          
   173: |                  ELSE
   174: |          
   175: |                    ! 2.1.1.2 grasses
   176: |          
   177: |V=====              fpc_nat(:,j) = cn_ind(:,j) * ind(:,j) * &
   178: |                                   ( 1. - exp( -lai(:,j) * ext_coeff(j) ) )
   179: |          
   180: |                  ENDIF  ! tree/grass
   181: |          
   182: |                ELSE
   183: |          
   184: |                  ! 2.1.2 agricultural PFTs: not present on natural part
   185: |          
   186: |V=====            fpc_nat(:,j) = 0.0
   187: |          
   188: |                ENDIF    ! natural/agricultural
   189: |          
   190: +------        ENDDO
   191:            
   192:                !
   193:                ! 2.2 sum natural fpc for every grid point
   194:                !
   195:            
   196: V======        sumfpc(:) = zero
   197: +------>       DO j = 1, npft
   198: |V=====          sumfpc(:) = sumfpc(:) + fpc_nat(:,j)
   199: +------        ENDDO
   200:            
   201:                !
   202:                ! 3 Light competition
   203:                !
   204:            
   205: +V=====        light_death(:,:) = 0.0
   206:            
   207: +------>       DO i = 1, npts
   208: |          
   209: |                ! Only if vegetation cover is dense
   210: |          
   211: |                IF ( sumfpc(i) .GT. fpc_crit ) THEN
   212: |          
   213: |                  ! fpc change for each pft
   214: |                  ! There are two possibilities: either we compare today's fpc with the fpc after the last
   215: |                  ! time step, or we compare it to last year's maximum fpc of that PFT. In the first case,
   216: |                  ! the fpc increase will be strong for seasonal PFTs at the beginning of the growing season.
   217: |                  ! As for trees, the cutback is proportional to this increase, this means that seasonal trees
   218: |                  ! will be disadvantaged compared to evergreen trees. In the original LPJ model, with its 
   219: |                  ! annual time step, the second method was used (this corresponds to annual_increase=.TRUE.)
   220: |          
   221: |                  IF ( annual_increase ) THEN
   222: |V=====              deltafpc(:) = MAX( (fpc_nat(i,:)-maxfpc_lastyear(i,:)), 0._r_std )
   223: |                  ELSE
   224: |+=====              deltafpc(:) = MAX( (fpc_nat(i,:)-veget_lastlight(i,:)), 0._r_std )
   225: |                  ENDIF
   226: |          
   227: |                  ! default: survive
   228: |          
   229: |V=====            survive(:) = 1.0
   230: |          
   231: |                  !
   232: |                  ! 3.1 determine some characteristics of the fpc distribution
   233: |                  !
   234: |          
   235: |                  sumfpc_wood = 0.0
   236: |                  sumdelta_fpc_wood = 0.0
   237: |                  maxfpc_wood = 0.0
   238: |                  optpft_wood = 0
   239: |                  sumfpc_grass = 0.0
   240: |                  num_grass = 0
   241: |          
   242: |V----->           DO j = 1, npft
   243: ||         
   244: ||                   ! only natural pfts
   245: ||         
   246: ||                   IF ( natural(j) ) THEN
   247: ||         
   248: ||                     IF ( tree(j) ) THEN
   249: ||         
   250: ||                       ! trees
   251: ||         
   252: ||                       ! total woody fpc
   253: ||         
   254: ||                       sumfpc_wood = sumfpc_wood + fpc_nat(i,j)
   255: ||         
   256: ||                       ! how much did the woody fpc increase
   257: ||         
   258: ||                       sumdelta_fpc_wood = sumdelta_fpc_wood + deltafpc(j)
   259: ||         
   260: ||                       ! which woody pft is preponderant
   261: ||         
   262: ||                       IF ( fpc_nat(i,j) .GT. maxfpc_wood ) THEN
   263: ||         
   264: ||                         optpft_wood = j
   265: ||         
   266: ||                         maxfpc_wood = fpc_nat(i,j)
   267: ||         
   268: ||                       ENDIF
   269: ||         
   270: ||                     ELSE
   271: ||         
   272: ||                       ! grasses
   273: ||         
   274: ||                       ! total (natural) grass fpc
   275: ||         
   276: ||                       sumfpc_grass = sumfpc_grass + fpc_nat(i,j)
   277: ||         
   278: ||                       ! number of grass PFTs present in the grid box
   279: ||         
   280: ||                       IF ( PFTpresent(i,j) ) THEN
   281: ||                         num_grass = num_grass + 1
   282: ||                       ENDIF
   283: ||         
   284: ||                     ENDIF   ! tree or grass
   285: ||         
   286: ||                   ENDIF   ! natural
   287: ||         
   288: |V-----            ENDDO     ! loop over pfts
   289: |          
   290: |                  !
   291: |                  ! 3.2 light competition: assume wood outcompetes grass
   292: |                  !
   293: |          
   294: |                  IF (sumfpc_wood .GE. fpc_crit ) THEN
   295: |          
   296: |                    !
   297: |                    ! 3.2.1 all allowed natural space is covered by wood:
   298: |                    !       cut back trees to fpc_crit.
   299: |                    !       Original DGVM: kill grasses. Modified: we let a very
   300: |                    !       small fraction of grasses survive.
   301: |                    !
   302: |          
   303: |V----->             DO j = 1, npft
   304: ||         
   305: ||                     ! only present and natural pfts compete
   306: ||         
   307: ||                     IF ( PFTpresent(i,j) .AND. natural(j) ) THEN
   308: ||         
   309: ||                       IF ( tree(j) ) THEN
   310: ||         
   311: ||                         !
   312: ||                         ! 3.2.1.1 tree
   313: ||                         !
   314: ||         
   315: ||                         IF ( maxfpc_wood .GE. fpc_crit ) THEN
   316: ||         
   317: ||                           ! 3.2.1.1.1 one single woody pft is overwhelming
   318: ||         
   319: ||                           IF ( j .eq. optpft_wood ) THEN
   320: ||         
   321: ||                             ! reduction for this dominant pft
   322: ||         
   323: ||                             reduct = 1. - fpc_crit / fpc_nat(i,j)
   324: ||         
   325: ||                           ELSE
   326: ||         
   327: ||                             ! strongly reduce all other woody pfts
   328: ||                             !   (original DGVM: tree_mercy = 0.0 )
   329: ||         
   330: ||                             reduct = 1. - tree_mercy
   331: ||         
   332: ||                           ENDIF   ! pft = dominant woody pft
   333: ||         
   334: ||                         ELSE
   335: ||         
   336: ||                           ! 3.2.1.1.2 no single woody pft is overwhelming
   337: ||                           !           (original DGVM: tree_mercy = 0.0 )
   338: ||                           !           The reduction rate is proportional to the ratio deltafpc/fpc.
   339: ||         
   340: ||                           IF ( fpc_nat(i,j) .GE. min_stomate ) THEN
   341: ||         
   342: ||                             reduct = MIN( ( ( deltafpc(j)/sumdelta_fpc_wood * &
   343: ||                                               (sumfpc_wood-fpc_crit) ) / fpc_nat(i,j) ), &
   344: ||                                             ( 1._r_std - tree_mercy ) )
   345: ||         
   346: ||                           ELSE
   347: ||         
   348: ||                             ! tree fpc didn't icrease or it started from nothing
   349: ||         
   350: ||                             reduct = 0.
   351: ||         
   352: ||                           ENDIF
   353: ||         
   354: ||                         ENDIF   ! maxfpc_wood > fpc_crit
   355: ||         
   356: ||                         survive(j) = 1. - reduct
   357: ||         
   358: ||                       ELSE
   359: ||         
   360: ||                         !
   361: ||                         ! 3.2.1.2 grass: let a very small fraction survive (the sum of all
   362: ||                         !         grass individuals may make up a maximum cover of
   363: ||                         !         grass_mercy [for lai -> infinity]).
   364: ||                         !         In the original DGVM, grasses were killed in that case,
   365: ||                         !         corresponding to grass_mercy = 0.
   366: ||                         !
   367: ||         
   368: ||                         survive(j) = ( grass_mercy / REAL( num_grass,r_std ) ) / ind(i,j)
   369: ||         
   370: ||                         survive(j) = MIN( 1._r_std, survive(j) )
   371: ||         
   372: ||                       ENDIF   ! tree or grass
   373: ||         
   374: ||                     ENDIF     ! pft there and natural
   375: ||         
   376: |V-----              ENDDO       ! loop over pfts
   377: |          
   378: |                  ELSE
   379: |          
   380: |                    !
   381: |                    ! 3.2.2 not too much wood so that grasses can subsist
   382: |                    !
   383: |          
   384: |                    ! new total grass fpc
   385: |                    sumfpc_grass2 = fpc_crit - sumfpc_wood
   386: |          
   387: |V----->             DO j = 1, npft
   388: ||         
   389: ||                     ! only present and natural PFTs compete
   390: ||         
   391: ||                     IF ( PFTpresent(i,j) .AND. natural(j) ) THEN
   392: ||         
   393: ||                       IF ( tree(j) ) THEN
   394: ||         
   395: ||                         ! no change for trees
   396: ||         
   397: ||                         survive(j) = 1.0
   398: ||         
   399: ||                       ELSE
   400: ||         
   401: ||                         ! grass: fractional loss is the same for all grasses
   402: ||         
   403: ||                         IF ( sumfpc_grass .GT. min_stomate ) THEN
   404: ||                           survive(j) = sumfpc_grass2 / sumfpc_grass
   405: ||                         ELSE
   406: ||                           survive(j)=  0.0
   407: ||                         ENDIF
   408: ||         
   409: ||                       ENDIF
   410: ||         
   411: ||                     ENDIF    ! pft there and natural
   412: ||         
   413: |V-----              ENDDO       ! loop over pfts
   414: |          
   415: |                  ENDIF    ! sumfpc_wood > fpc_crit
   416: |          
   417: |                  !
   418: |                  ! 3.3 update output variables
   419: |                  !
   420: |          
   421: |+----->           DO j = 1, npft
   422: ||         
   423: ||                   IF ( PFTpresent(i,j) .AND. natural(j) ) THEN
   424: ||         
   425: ||V---->               bm_to_litter(i,j,:) = bm_to_litter(i,j,:) + &
   426: |||                                          biomass(i,j,:) * ( 1. - survive(j) )
   427: |||        
   428: ||V----                biomass(i,j,:) = biomass(i,j,:) * survive(j)
   429: ||         
   430: ||                     IF ( control%ok_dgvm ) THEN
   431: ||                       ind(i,j) = ind(i,j) * survive(j)
   432: ||                     ENDIF
   433: ||         
   434: ||                     ! fraction of plants that dies each day. 
   435: ||                     ! exact formulation: light_death(i,j) = 1. - survive(j) ** (1/dt)
   436: ||                     light_death(i,j) = ( 1. - survive(j) ) / dt
   437: ||         
   438: ||                   ENDIF      ! pft there and natural
   439: ||         
   440: |+-----            ENDDO        ! loop over pfts
   441: |          
   442: |                ENDIF      ! sumfpc > fpc_crit
   443: |          
   444: +------        ENDDO        ! loop over grid points
   445:            
   446:                !
   447:                ! 4 recalculate fpc on natural part of grid cell (for next light competition)
   448:                !
   449:            
   450: +------>       DO j = 1, npft
   451: |          
   452: |                IF ( natural(j) ) THEN
   453: |          
   454: |                  !
   455: |                  ! 4.1 natural PFTs
   456: |                  !
   457: |          
   458: |                  IF ( tree(j) ) THEN
   459: |          
   460: |                    ! 4.1.1 trees: minimum cover due to stems, branches etc.
   461: |          
   462: |V----->             DO i = 1, npts
   463: ||         
   464: ||                     veget_lastlight(i,j) = &
   465: ||                        cn_ind(i,j) * ind(i,j) * &
   466: ||                        MAX( ( 1._r_std - exp( -lai(i,j) * ext_coeff(j) ) ), min_cover )
   467: ||         
   468: |V-----              ENDDO
   469: |          
   470: |                  ELSE
   471: |          
   472: |                    ! 4.1.2 grasses
   473: |          
   474: |V=====              veget_lastlight(:,j) = &
   475: |                       cn_ind(:,j) * ind(:,j) * ( 1. - exp( -lai(:,j) * ext_coeff(j) ) )
   476: |          
   477: |                  ENDIF    ! tree/grass
   478: |          
   479: |                ELSE
   480: |          
   481: |                  !
   482: |                  ! 4.2 agricultural PFTs: not present on natural part
   483: |                  !
   484: |          
   485: |V=====            veget_lastlight(:,j) = 0.0
   486: |          
   487: |                ENDIF      ! natural/agricultural
   488: |          
   489: +------        ENDDO
   490:            
   491:                !
   492:                ! 5 history
   493:                !
   494:            
   495:                CALL histwrite (hist_id_stomate, 'LIGHT_DEATH', itime, &
   496:                                light_death, npts*npft, horipft_index)
   497:            
   498:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving light'
   499:            
   500:              END SUBROUTINE light
   501:            
   502:            END MODULE lpj_light
