Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:42 2008
FILE NAME: i.stomate_assimtemp.f90
PROGRAM NAME: stomate_assimtemp
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    53  vec  (   4): Vectorized array expression.
    55  vec  (   3): Unvectorized loop.
    55  vec  (  13): Overhead of loop division is too large.
    61  vec  (   4): Vectorized array expression.
    70  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:42 2008
FILE NAME: i.stomate_assimtemp.f90
PROGRAM NAME: stomate_assimtemp
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! calculates the photosynthesis temperatures
     2:            !
     3:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_assimtemp.f90,v 1.6 2007/05/28 14:49:02 ssipsl Exp $
     4:            ! IPSL (2006)
     5:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     6:            !
     7:            MODULE stomate_assimtemp
     8:            
     9:              ! modules used:
    10:            
    11:              USE stomate_constants
    12:            
    13:              IMPLICIT NONE
    14:            
    15:              ! private & public routines
    16:            
    17:              PRIVATE
    18:              PUBLIC assim_temp
    19:            
    20:            CONTAINS
    21:            
    22:              SUBROUTINE assim_temp (npts, tlong_ref, t2m_month, t_photo_min, t_photo_opt, t_photo_max)
    23:            
    24:                !
    25:                ! 0 declarations
    26:                !
    27:            
    28:                ! 0.1 input
    29:            
    30:                ! Domain size
    31:                INTEGER(i_std), INTENT(in)                                        :: npts
    32:                ! "long term" 2 meter reference temperatures (K)
    33:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: tlong_ref
    34:                ! "monthly" 2-meter temperatures (K)
    35:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m_month
    36:            
    37:                ! 0.2 output
    38:                ! Minimum temperature for photosynthesis (K)
    39:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: t_photo_min
    40:                ! Optimum temperature for photosynthesis (K)
    41:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: t_photo_opt
    42:                ! Maximum temperature for photosynthesis (K)
    43:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: t_photo_max
    44:            
    45:                ! 0.3 local
    46:                ! "long term" 2 meter reference temperatures (deg C)
    47:                REAL(r_std), DIMENSION(npts)                                :: tl
    48:                ! Index
    49:                INTEGER(i_std)                                             :: j
    50:            
    51:                ! =========================================================================
    52:            
    53: V======        tl(:) = tlong_ref(:) - ZeroCelsius
    54:            
    55: +------>       DO j = 1, npft
    56: |          
    57: |                !
    58: |                ! 1 normal case
    59: |                !
    60: |          
    61: |V----->         t_photo_min(:,j) = t_photo%t_min_c(j) + t_photo%t_min_b(j)*tl(:) + t_photo%t_min_a(j)*tl(:)*tl(:) + ZeroCelsius
    62: ||               t_photo_opt(:,j) = t_photo%t_opt_c(j) + t_photo%t_opt_b(j)*tl(:) + t_photo%t_opt_a(j)*tl(:)*tl(:) + ZeroCelsius
    63: |V-----          t_photo_max(:,j) = t_photo%t_max_c(j) + t_photo%t_max_b(j)*tl(:) + t_photo%t_max_a(j)*tl(:)*tl(:) + ZeroCelsius
    64: |          
    65: |                !
    66: |                ! 2 If the monthly temperature is too low, we set tmax < tmin.
    67: |                !   Therefore, photosynthesis will not be possible (we need tmin < t < tmax)
    68: |                !
    69: |          
    70: |V----->         WHERE ( t2m_month(:) .LT. t_photo_min(:,j) )
    71: |V-----            t_photo_max(:,j) = t_photo_min(:,j) - min_stomate
    72: |                ENDWHERE
    73: |          
    74: +------        ENDDO
    75:            
    76:              END SUBROUTINE assim_temp
    77:            
    78:            END MODULE stomate_assimtemp
