Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:42 2008
FILE NAME: i.stomate_vmax.f90
PROGRAM NAME: stomate_vmax
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   111  opt  (1593): Loop nest collapsed into one loop.
   111  vec  (   4): Vectorized array expression.
   124  opt  (1593): Loop nest collapsed into one loop.
   124  vec  (   4): Vectorized array expression.
   124  vec  (   4): Vectorized array expression.
   124  vec  (   4): Vectorized array expression.
   124  vec  (   4): Vectorized array expression.
   137  vec  (   3): Unvectorized loop.
   137  vec  (  13): Overhead of loop division is too large.
   142  vec  (   4): Vectorized array expression.
   147  vec  (   4): Vectorized array expression.
   147  vec  (   4): Vectorized array expression.
   147  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   155  vec  (   4): Vectorized array expression.
   159  vec  (   4): Vectorized array expression.
   159  vec  (   4): Vectorized array expression.
   168  vec  (   4): Vectorized array expression.
   178  vec  (   4): Vectorized array expression.
   178  vec  (   4): Vectorized array expression.
   178  vec  (   4): Vectorized array expression.
   191  vec  (   4): Vectorized array expression.
   191  vec  (   4): Vectorized array expression.
   191  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   204  vec  (   4): Vectorized array expression.
   209  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   233  opt  (1057): Complicated use of variable inhibits loop optimization.
   239  vec  (   3): Unvectorized loop.
   239  vec  (  13): Overhead of loop division is too large.
   241  vec  (   4): Vectorized array expression.
   255  vec  (   4): Vectorized array expression.
   255  vec  (   4): Vectorized array expression.
   255  vec  (   4): Vectorized array expression.
   255  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:42 2008
FILE NAME: i.stomate_vmax.f90
PROGRAM NAME: stomate_vmax
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! calculates the leaf efficiency
     2:            !
     3:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_vmax.f90,v 1.8 2007/05/28 14:49:02 ssipsl Exp $
     4:            ! IPSL (2006)
     5:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     6:            !
     7:            MODULE stomate_vmax
     8:            
     9:              ! modules used:
    10:            
    11:              USE ioipsl
    12:              USE stomate_constants
    13:            
    14:              IMPLICIT NONE
    15:            
    16:              ! private & public routines
    17:            
    18:              PRIVATE
    19:              PUBLIC vmax, vmax_clear
    20:            
    21:              ! first call
    22:              LOGICAL, SAVE                                              :: firstcall = .TRUE.
    23:            
    24:            CONTAINS
    25:            
    26:              SUBROUTINE vmax_clear
    27:                firstcall=.TRUE.
    28:              END SUBROUTINE vmax_clear
    29:            
    30:              SUBROUTINE vmax (npts, dt, &
    31:                               leaf_age, leaf_frac, &
    32:                               vcmax, vjmax)
    33:            
    34:                !
    35:                ! 0 declarations
    36:                !
    37:            
    38:                ! 0.1 input
    39:            
    40:                ! Domain size
    41:                INTEGER(i_std), INTENT(in)                                        :: npts
    42:                ! time step of Stomate in days
    43:                REAL(r_std), INTENT(in)                                     :: dt
    44:            
    45:                ! 0.2 modified fields
    46:            
    47:                ! leaf age (days)
    48:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_age
    49:                ! fraction of leaves in leaf age class
    50:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_frac
    51:            
    52:                ! 0.3 output
    53:            
    54:                ! Maximum rate of carboxylation
    55:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: vcmax
    56:                ! Maximum rate of RUbp regeneration
    57:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: vjmax
    58:            
    59:                ! 0.4 local
    60:            
    61:                ! offset (minimum relative vcmax)
    62:                REAL(r_std), PARAMETER                                      :: vmax_offset = 0.3
    63:                ! leaf age at which vmax attains vcmax_opt (in fraction of critical leaf age)
    64:                REAL(r_std), PARAMETER                                      :: leafage_firstmax = 0.03
    65:                ! leaf age at which vmax falls below vcmax_opt (in fraction of critical leaf age)
    66:                REAL(r_std), PARAMETER                                      :: leafage_lastmax = 0.5
    67:                ! leaf age at which vmax attains its minimum (in fraction of critical leaf age)
    68:                REAL(r_std), PARAMETER                                      :: leafage_old = 1.
    69:                ! leaf efficiency (vcmax/vcmax_opt)
    70:                REAL(r_std), DIMENSION(npts)                                :: leaf_efficiency
    71:                ! change of fraction of leaves in age class
    72:                REAL(r_std), DIMENSION(npts,npft,nleafages)                 :: d_leaf_frac
    73:                ! new leaf age (d)
    74:                REAL(r_std), DIMENSION(npts,nleafages)                      :: leaf_age_new
    75:                ! sum of leaf age fractions, for normalization
    76:                REAL(r_std), DIMENSION(npts)                                :: sumfrac
    77:                ! relative leaf age (age/critical age)
    78:                REAL(r_std), DIMENSION(npts)                                :: rel_age
    79:                ! Index
    80:                INTEGER(i_std)                                              :: j,m
    81:            
    82:                ! =========================================================================
    83:            
    84:                IF (bavard.GE.3) WRITE(numout,*) 'Entering vmax'
    85:            
    86:                !
    87:                ! 1 Initialization
    88:                !
    89:            
    90:                !
    91:                ! 1.1 first call: info about flags and parameters.
    92:                !
    93:            
    94:                IF ( firstcall ) THEN
    95:            
    96:                  WRITE(numout,*) 'vmax:'
    97:            
    98:                  WRITE(numout,*) '   > offset (minimum vcmax/vmax_opt):' , vmax_offset
    99:                  WRITE(numout,*) '   > relative leaf age at which vmax attains vcmax_opt:', leafage_firstmax
   100:                  WRITE(numout,*) '   > relative leaf age at which vmax falls below vcmax_opt:', leafage_lastmax
   101:                  WRITE(numout,*) '   > relative leaf age at which vmax attains its minimum:', leafage_old
   102:            
   103:                  firstcall = .FALSE.
   104:            
   105:                ENDIF
   106:            
   107:                !
   108:                ! 1.2 initialize output
   109:                !
   110:            
   111: *W----->       vcmax(:,:) = 0.0
   112: *W-----        vjmax(:,:) = 0.0
   113:            
   114:                !
   115:                ! 2 leaf age: general increase and turnover between age classes.
   116:                !
   117:            
   118:                !
   119:                ! 2.1 increase leaf age
   120:                !
   121:            
   122: *------>       DO m = 1, nleafages
   123: |          
   124: |*W---->         WHERE ( leaf_frac(:,:,m) .GT. min_stomate )
   125: |||        
   126: |*W----            leaf_age(:,:,m) = leaf_age(:,:,m) + dt
   127: |          
   128: |                ENDWHERE
   129: |          
   130: *------        ENDDO
   131:            
   132:                !
   133:                ! 2.2 turnover between leaf age classes
   134:                !     d_leaf_frac(:,:,m) = what leaves m-1 and goes into m
   135:                !
   136:            
   137: +------>       DO j = 1, npft
   138: |          
   139: |                ! 2.2.1 fluxes
   140: |          
   141: |                ! nothing goes into first age class
   142: |V=====          d_leaf_frac(:,j,1) = 0.0
   143: |          
   144: |                ! from m-1 to m
   145: |+----->         DO m = 2, nleafages 
   146: ||         
   147: ||V====            d_leaf_frac(:,j,m) = leaf_frac(:,j,m-1) * dt/leaf_timecst(j)
   148: ||         
   149: |+-----          ENDDO
   150: |          
   151: |                ! 2.2.2 new leaf age in class
   152: |                !       new age = ( old age * old fraction + fractional increase * age of source ) /
   153: |                !                 new fraction
   154: |          
   155: |+V====          leaf_age_new(:,:) = 0.0
   156: |          
   157: |*----->         DO m = 2, nleafages-1
   158: ||         
   159: ||V---->           WHERE ( d_leaf_frac(:,j,m) .GT. min_stomate )
   160: |||        
   161: ||V----              leaf_age_new(:,m) = ( ( (leaf_frac(:,j,m)- d_leaf_frac(:,j,m+1)) * leaf_age(:,j,m) )  + &
   162: ||                                         ( d_leaf_frac(:,j,m) * leaf_age(:,j,m-1) ) ) / &
   163: ||                                       ( leaf_frac(:,j,m) + d_leaf_frac(:,j,m)- d_leaf_frac(:,j,m+1) )
   164: ||         
   165: ||                 ENDWHERE
   166: ||         
   167: |*-----          ENDDO       ! Loop over age classes
   168: |V----->          WHERE ( d_leaf_frac(:,j,nleafages) .GT. min_stomate )
   169: ||         
   170: |V-----              leaf_age_new(:,nleafages) = ( ( leaf_frac(:,j,nleafages) * leaf_age(:,j,nleafages) )  + &
   171: |                                          ( d_leaf_frac(:,j,nleafages) * leaf_age(:,j,nleafages-1) ) ) / &
   172: |                                        ( leaf_frac(:,j,nleafages) + d_leaf_frac(:,j,nleafages) )
   173: |          
   174: |                  ENDWHERE
   175: |          
   176: |*----->         DO m = 2, nleafages
   177: ||         
   178: ||V---->           WHERE ( d_leaf_frac(:,j,m) .GT. min_stomate )
   179: |||        
   180: ||V----              leaf_age(:,j,m) = leaf_age_new(:,m)
   181: ||         
   182: ||                 ENDWHERE
   183: ||         
   184: |*-----          ENDDO       ! Loop over age classes
   185: |          
   186: |                ! 2.2.3 calculate new fraction
   187: |          
   188: |*----->         DO m = 2, nleafages
   189: ||         
   190: ||                 ! where the change comes from
   191: ||V---->           leaf_frac(:,j,m-1) = leaf_frac(:,j,m-1) - d_leaf_frac(:,j,m)
   192: |||        
   193: |||                ! where it goes to
   194: ||V----            leaf_frac(:,j,m) = leaf_frac(:,j,m) + d_leaf_frac(:,j,m)
   195: ||         
   196: |*-----          ENDDO
   197: |          
   198: |                ! 2.2.4 renormalize fractions in order to prevent accumulation 
   199: |                !       of numerical errors
   200: |          
   201: |                ! correct small negative values
   202: |          
   203: |+----->         DO m = 1, nleafages
   204: ||V====            leaf_frac(:,j,m) = MAX( 0._r_std, leaf_frac(:,j,m) )
   205: |+-----          ENDDO
   206: |          
   207: |                ! total of fractions, should be very close to one where there is leaf mass
   208: |          
   209: |V=====          sumfrac(:) = 0.0
   210: |          
   211: |+----->         DO m = 1, nleafages
   212: ||         
   213: ||V====            sumfrac(:) = sumfrac(:) + leaf_frac(:,j,m)
   214: ||         
   215: |+-----          ENDDO
   216: |          
   217: |                ! normalize
   218: |          
   219: |*----->         DO m = 1, nleafages
   220: ||         
   221: ||V---->           WHERE ( sumfrac(:) .GT. min_stomate )
   222: |||        
   223: |||                  leaf_frac(:,j,m) = leaf_frac(:,j,m) / sumfrac(:) 
   224: |||        
   225: |||                ELSEWHERE
   226: |||        
   227: ||V----              leaf_frac(:,j,m) = 0.0
   228: ||         
   229: ||                 ENDWHERE
   230: ||         
   231: |*-----          ENDDO
   232: |          
   233: +------        ENDDO         ! Loop over PFTs
   234:            
   235:                !
   236:                ! 3 calculate vmax as a function of the age
   237:                !
   238:            
   239: +------>       DO j = 1, npft
   240: |          
   241: |V----->         vcmax(:,j) = 0.0
   242: |V-----          vjmax(:,j) = 0.0
   243: |          
   244: |                ! sum up over the different age classes
   245: |          
   246: |*----->         DO m = 1, nleafages
   247: ||         
   248: ||                 !
   249: ||                 ! 3.1 efficiency in each of the age classes
   250: ||                 !     increases from 0 to 1 at the beginning (rel_age < leafage_firstmax), stays 1
   251: ||                 !     until rel_age = leafage_lastmax, then decreases to vmax_offset at 
   252: ||                 !     rel_age = leafage_old, then stays at vmax_offset.
   253: ||                 !
   254: ||         
   255: ||V---->           rel_age(:) = leaf_age(:,j,m) / pheno_crit%leafagecrit(j)
   256: |||        
   257: |||                leaf_efficiency(:) = MAX( vmax_offset, MIN( 1._r_std, &
   258: |||                     vmax_offset + (1._r_std-vmax_offset) * rel_age(:) / leafage_firstmax, &
   259: |||                     1._r_std - (1._r_std-vmax_offset) * ( rel_age(:) - leafage_lastmax ) / &
   260: |||                                                        ( leafage_old - leafage_lastmax ) ) )
   261: |||        
   262: |||                !
   263: |||                ! 3.2 add to mean vmax
   264: |||                !
   265: |||        
   266: |||                vcmax(:,j) = vcmax(:,j) + vcmax_opt(j) * leaf_efficiency(:) * leaf_frac(:,j,m)
   267: ||V----            vjmax(:,j) = vjmax(:,j) + vjmax_opt(j) * leaf_efficiency(:) * leaf_frac(:,j,m)
   268: ||         
   269: |*-----          ENDDO     ! loop over age classes
   270: |          
   271: +------        ENDDO       ! loop over PFTs
   272:            
   273:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving vmax'
   274:            
   275:              END SUBROUTINE vmax
   276:            
   277:            END MODULE stomate_vmax
